import ij.IJ;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

public class ImageListJTable extends JTable {
	ImageList list;

	ImageListJTable ( ImageList imageList ){
		super( imageList );
		list = imageList;
		if (IJ.isLinux()) setBackground(Color.white);
		setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
		setAutoResizeMode( JTable.AUTO_RESIZE_OFF );
		resizeColumn( imageList.COLUMN_SYNCROI );
	}

	public void resizeColumn( int column ){
		if( getRowCount()==0 ) {
			list.addRow( new Object[]{ "    ", "Sync", "DIR34567890", "TITLE56789012345", "TYPE", "WIDT", "HEIG", "SLIC" } );
			for( int i=0; i<ImageList.columns.length; i++ )
				resizeColumn0( i );
			list.removeRow( 0 );
		} else
			resizeColumn0( column );
	}

	void resizeColumn0( int column ) {
		TableColumnModel columnModel = this.getColumnModel();
		int maxwidth = 0;
		for( int row=0; row<this.getRowCount(); row++ ){
			TableCellRenderer rend = this.getCellRenderer( row, column );
			Component comp = rend.getTableCellRendererComponent(
					this,
					this.getValueAt( row, column ),
					false, false,
					row, column );
			maxwidth = Math.max( comp.getPreferredSize().width, maxwidth );
		}
		TableColumn tablecolumn = columnModel.getColumn( column );
		tablecolumn.setMaxWidth( maxwidth*2 );		
		tablecolumn.setPreferredWidth( maxwidth+1 );
		this.revalidate();
	};
}
